# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define reltag .redhat_2
%define namedreltag -redhat-2
%global namedversion %{version}%{?namedreltag}

%define maven_version 0.6-redhat-2

Name:           apache-mime4j
Version:        0.6
Release:        7%{?reltag}%{?dist}.5
Epoch:          0
Summary:        Mime stream parser
Group:          Development/Libraries/Java

%if %with mead
Source100: org.apache.james-apache-mime4j-0.6-redhat-2-sources.zip
Source101: org.apache.james-apache-mime4j-0.6-redhat-2-patches.zip
Source102: apache-mime4j-0.6-redhat-2-bin.zip
Source103: apache-mime4j-0.6-redhat-2-javadoc.jar
Source104: apache-mime4j-0.6-redhat-2-site.xml
Source105: apache-mime4j-0.6-redhat-2-src.tar.gz
Source106: apache-mime4j-0.6-redhat-2.jar
Source107: apache-mime4j-0.6-redhat-2-bin.tar.gz
Source108: apache-mime4j-0.6-redhat-2.pom
Source109: apache-mime4j-0.6-redhat-2-sources.jar
Source110: apache-mime4j-0.6-redhat-2-src.zip
%endif

License:        BSD
URL:            http://james.apache.org/mime4j
%if %without mead
Source0:        http://www.apache.org/dist/james/mime4j/apache-mime4j-0.6-src.tar.gz
Patch0:         %{name}-pom.patch
Patch1:         %{name}-TestHandler.patch
Patch2:         %{name}-vman_pom.patch
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       slf4j
%if %without mead
BuildRequires:  apache-jar-resource-bundle >= 0:1.3
BuildRequires:  james-project >= 0:1.2
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-shared-downloader
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  javacc-maven-plugin
BuildRequires:  maven-bundle-plugin
BuildRequires:  commons-parent
BuildRequires:  commons-io
BuildRequires:  log4j
BuildRequires:  slf4j
BuildRequires:  jboss-parent
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache Mime4j is developed by the Apache James team but now
has a dedicated mailing list.
mime4j provides a parser, MimeStreamParser, for e-mail 
message streams in plain rfc822 and MIME format. The parser 
uses a callback mechanism to report parsing events such as 
the start of an entity header, the start of a body, etc. If 
you are familiar with the SAX XML parser interface you 
should have no problem getting started with mime4j.
The parser only deals with the structure of the message 
stream. It won't do any decoding of base64 or quoted-printable 
encoded header fields and bodies. This is intentional - the 
parser should only provide the most basic functionality needed 
to build more complex parsers. However, mime4j does include 
facilities to decode bodies and fields and the Message class 
described below handles decoding of fields and bodies 
transparently. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q 
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p1 -b .sav2
%endif

%build
%if %without mead
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
%endif

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p target/apache-mime4j-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}
%{__ln_s} %{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-sources.jar
%endif
%{__ln_s} %{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}.jar

%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%endif
%add_to_maven_depmap org.apache.james apache-mime4j %{namedversion} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%endif
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc BUILDING.txt LICENSE.txt NOTICE.txt RELEASE_NOTES.txt
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%else
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%endif
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.6-7.redhat_2.5
- Rebuild for MD5

* Sat Sep 01 2012 Paul Gier <pgier@redhat.com> - 0:0.6-6.redhat_2.5
- Pom updates for unsigned rebuild

* Mon Aug 13 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.6-6.redhat_2.4
- Rebuild unsigned

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.6-6.redhat_2.3
- Rebuild unsigned

* Wed Jul 18 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.6-6.redhat_1.2
- Rebuild using cache signing

* Wed Jul 18 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.6-6.redhat_1.1
- Rebuild using cache signing

* Thu Jul 12 2012 Hui Wang <huwang@redhat.com> - 0:0.6-6_redhat_1
- First mead build

* Mon Apr 16 2012 Martha Benitez <mbenitez@redhat.com> - 0:0.6-5.redhat_1
- Update vman.patch using vman-1.0.6-redhat-1

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.6-4_redhat_1.1
- Rebuild using cache signing

* Mon Feb 13 2012 David Walluck <dwalluck@redhat.com> 0:0.6-4
- replace commons-logging by jcl-over-slf4j
- javadoc requires jpackage-utils
- fix repolib file ownership
- add more doc
- BuildRequires: jboss-parent
- use standalone javacc-maven-plugin
- use newer felix stack

* Tue Nov 15 2011 Martha Benitez <mbenitez@redhat.com> - 0:0.6-3_redhat_1
- Build for EAP6

* Tue Dec 14 2010 David Walluck <dwalluck@redhat.com> 0:0.6-2.1
- update file list for brew
- change apache (Build)Requires to jakarta for brew
- add repolib
- use 'mvn deploy'

* Tue Dec 14 2010 David Walluck <dwalluck@redhat.com> 0:0.6-2
- build with external apache-jar-resource-bundle-1.3
- build with external james-project-1.2
- remove BuildRequires: junit44

* Sat Oct 16 2010 Ralph Apel <r.apel@r-apel.de> 0.6-1
- first release
